package cn.jyjz.xiaoyao.createcode.createcode.java.htmlcode;


import cn.jyjz.xiaoyao.createcode.createcode.java.javacode.CreateController;
import cn.jyjz.xiaoyao.createcode.object.Column;
import cn.jyjz.xiaoyao.createcode.object.Table;
import cn.jyjz.xiaoyao.createcode.util.ForFileUtil;
import java.io.File;
import java.io.IOException;
import java.util.List;

/**
 * Created by zhangyong on 2018/3/5.
 */
public class CreateEdit {

    /**
     *
     * physicspath：文件实际保存路径
     * table 数据库表对象
     * htmlpath html存储路径
     *
     * */
    public static boolean createList(String physicspath, Table table, String htmlpath){

        htmlpath = htmlpath.replace("/",File.separator);

        if(htmlpath.endsWith(File.separator)){
            htmlpath = htmlpath.substring(0,htmlpath.length()-1);
        }

        //去掉路径上第一个分隔符
        if(htmlpath.startsWith(File.separator)){
            htmlpath = htmlpath.substring(1,htmlpath.length());
        }

        if(!physicspath.endsWith(File.separator)){
            physicspath = physicspath + File.separator;
        }

        //输出内容
        StringBuffer modeldata = new StringBuffer();

        //创建controller类的物理路径
        String changemodelpath = physicspath + htmlpath + File.separator + table.getJavaName().toLowerCase() + File.separator +"edit.html";

        modeldata.append(HtmlUtils.getAddHeader(CreateController.urlFormapPath(table.getJavaName()),table.getTableName()));

        modeldata.append("\n");

        modeldata.append("</head>\n");

        modeldata.append("<body class=\"gray-bg\">\n");

        //--------start
        modeldata.append("\t<div class=\"wrapper wrapper-content animated fadeInRight\">\n");
        modeldata.append("\t\t<div class=\"row\">\n");
        modeldata.append("\t\t\t<div class=\"col-sm-12\">\n");
        modeldata.append("\t\t\t\t<div class=\"ibox float-e-margins\">\n");
        modeldata.append("\t\t\t\t\t<div class=\"ibox-title\">\n");
        modeldata.append("\t\t\t\t\t\t<h5>基本信息</h5>\n");
        modeldata.append("\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t\t<div class=\"ibox-content\">\n");
        modeldata.append("\t\t\t\t\t\t<div class=\"main-content\">\n");
        modeldata.append("\t\t\t\t\t\t\t<form name=\"" + table.getJavaName() + "form\" method=\"post\"  id=\"" + table.getJavaName() + "form\" class=\"form-horizontal\" action=\"${ctx}" + CreateController.urlFormapPath(table.getJavaName()) + "/edit" +  "\">\n");
        modeldata.append("\t\t\t\t\t\t\t\t\n");
        modeldata.append("\t\t\t\t\t\t\t\t<input type=\"hidden\" id=\"id\" name=\"id\">\n");


        //form表单------start
        modeldata.append(foramatForm(table.getColumnList(),table));

        modeldata.append("\t\t\t\t\t\t\t\t<div class=\"row\">\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t<div class=\"form-group\">\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t\t<div class=\"col-sm-offset-5\">\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t\t\t<button type=\"submit\" class=\"btn btn-w-m btn-primary\">保存</button>\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t\t\t<button type=\"button\" onclick=\"rolesback()\" class=\"btn btn-w-m btn-success\">取消</button>\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t\t\t\t\t</div>\n");
        //form表单------end

        modeldata.append("\t\t\t\t\t\t\t</form>\n");
        modeldata.append("\t\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t\t</div>\n");
        modeldata.append("\t\t\t\t</div>\n");
        modeldata.append("\t\t\t</div>\n");
        modeldata.append("\t\t</div>\n");
        modeldata.append("\t</div>\n");
        //--------end

        //javaScript代码-------start
        StringBuffer scriptDate = new StringBuffer();

        scriptDate.append("<script type=\"text/javascript\">\n");

        scriptDate.append("\t$(document).ready(function () {\n");


        //通过ajax获取对象信息
        scriptDate.append(foramatFormAjax(table.getColumnList(),table,htmlpath));

        scriptDate.append("\t\t$('.i-checks').iCheck({\n");
        scriptDate.append("\t\t\tcheckboxClass: 'icheckbox_square-green',\n");
        scriptDate.append("\t\t\tradioClass: 'iradio_square-green',\n");
        scriptDate.append("\t\t});\n");


        //form提交开始
        scriptDate.append("\t\t$(\"#" + table.getJavaName() + "form\").attr(\"action\",\"${ctx}" + CreateController.urlFormapPath(htmlpath,table.getJavaName()) + "/edit\" + "  + ");\n");

        scriptDate.append( "\t\tvar form1 = $('#" + table.getJavaName() + "form');\n");
        scriptDate.append( "\t\tvar error1 = $('.alert-danger', form1);\n");

        scriptDate.append("\t\tform1.validate({\n");
        scriptDate.append("\t\t\tdebug: true,\n");
        scriptDate.append("\t\t\terrorElement: 'span',\n");
        scriptDate.append("\t\t\terrorClass: 'help-block help-block-error',\n");
        scriptDate.append("\t\t\tfocusInvalid: false,\n");
        scriptDate.append("\t\t\tignore: \":hidden\",\n");
        scriptDate.append("\t\t\terrorPlacement: function (error, element) { \n");
        scriptDate.append("\t\t\t\tif (element.parent(\".input-group\").size() > 0) {\n");
        scriptDate.append("\t\t\t\t\terror.insertAfter(element.parent(\".input-group\"));\n");
        scriptDate.append("\t\t\t\t} else if (element.attr(\"data-error-container\")) { \n");
        scriptDate.append("\t\t\t\t\terror.appendTo(element.attr(\"data-error-container\"));\n");
        scriptDate.append("\t\t\t\t} else if (element.parents('.radio-list').size() > 0) { \n");
        scriptDate.append("\t\t\t\terror.appendTo(element.parents('.radio-list').attr(\"data-error-container\"));\n");
        scriptDate.append("\t\t\t\t} else if (element.parents('.radio-inline').size() > 0) { \n");
        scriptDate.append("\t\t\t\t\terror.appendTo(element.parents('.radio-inline').attr(\"data-error-container\"));\n");
        scriptDate.append("\t\t\t\t} else if (element.parents('.checkbox-list').size() > 0) {\n");
        scriptDate.append("\t\t\t\t\terror.appendTo(element.parents('.checkbox-list').attr(\"data-error-container\"));\n");
        scriptDate.append("\t\t\t\t} else if (element.parents('.checkbox-inline').size() > 0) { \n");
        scriptDate.append("\t\t\t\t\terror.appendTo(element.parents('.checkbox-inline').attr(\"data-error-container\"));\n");
        scriptDate.append("\t\t\t\t} else {\n");
        scriptDate.append("\t\t\t\t\terror.insertAfter(element);\n");
        scriptDate.append("\t\t\t\t}\n");
        scriptDate.append("\t\t\t},\n");
        scriptDate.append("\t\t\thighlight: function (element) {\n");
        scriptDate.append("\t\t\t\t$(element).closest('.form-group').addClass('has-error');\n");
        scriptDate.append("\t\t\t},\n");
        scriptDate.append("\t\t\tunhighlight: function (element) {\n");
        scriptDate.append("\t\t\t\t$(element).closest('.form-group').removeClass('has-error');\n");
        scriptDate.append("\t\t\t},\n");
        scriptDate.append("\t\t\tsuccess: function (label) {\n");
        scriptDate.append("\t\t\t\tlabel.closest('.form-group').removeClass('has-error');\n");
        scriptDate.append("\t\t\t},\n");
        scriptDate.append("\t\t\tsubmitHandler: function (){\n");
        scriptDate.append("\t\t\t\tparent.layer.load();\n");
        scriptDate.append("\t\t\t\t$(\"#" + table.getJavaName() + "form\").ajaxSubmit({\n");

        scriptDate.append("\t\t\t\t\theaders:{\"logintoken\": parent.getLoginToken()},\n");
        scriptDate.append("\t\t\t\t\tsuccess:function(data){\n");
        scriptDate.append("\t\t\t\t\t\tparent.layer.closeAll('loading');\n");
        scriptDate.append("\t\t\t\t\t\tif(data.code == \"OK\"){\n");
        scriptDate.append("\t\t\t\t\t\t\tparent.toastr.success(data.message);\n");
        scriptDate.append("\t\t\t\t\t\t\trolesback();\n");
        scriptDate.append("\t\t\t\t\t\t}else if(data.code == \"ERRORM\"){\n");
        scriptDate.append("\t\t\t\t\t\t\t$.each(data.message,function(name,anArray) {\n");
        scriptDate.append("\t\t\t\t\t\t\t\t$.each(anArray,function(n,value){\n");
        scriptDate.append("\t\t\t\t\t\t\t\t\t$(\"#\" + n).closest('.form-group').addClass('has-error'); \n");
        scriptDate.append("\t\t\t\t\t\t\t\t\t$(\"<span>\").attr( \"id\", n + \"-error\" ).addClass(\"help-block help-block-error\").html(value).insertAfter($(\"#\" + n));\n");
        scriptDate.append("\t\t\t\t\t\t\t\t});\n");
        scriptDate.append("\t\t\t\t\t\t\t});\n");
        scriptDate.append("\t\t\t\t\t\t}else{\n");
        scriptDate.append("\t\t\t\t\t\t\tparent.toastr.error(data.message);\n");
        scriptDate.append("\t\t\t\t\t\t}\n");
        scriptDate.append("\t\t\t\t\t}\n");
        scriptDate.append("\t\t\t\t});\n");
        scriptDate.append("\t\t\t}\n");
        scriptDate.append("\t\t});\n");
        //form提交结束

        scriptDate.append("\t});\n");

        scriptDate.append("\tfunction rolesback() {\n");
        scriptDate.append("\t\tparent.closeItem(window.frameElement.name);\n");
        scriptDate.append("\t}\n");


        scriptDate.append("</script>\n");

        //javaScript代码-------end


        modeldata.append(HtmlUtils.getBootmAdd(scriptDate.toString()));



        try {
            return ForFileUtil.writeFileContent(changemodelpath,modeldata.toString());
        } catch (IOException e) {
            e.printStackTrace();
        }

        return false;
    }

    /**
     * 格式化js获取对象信息，并在给页面元素赋值
     * @param columns
     * @param table
     * @return
     */
    private static String foramatFormAjax(List<Column> columns, Table table,String htmlpath){
        StringBuffer returndata = new StringBuffer();

        returndata.append("\t\tparent.axgetXiaoyao('${ctx}" +  CreateController.urlFormapPath(htmlpath,table.getJavaName()) + "/getdata/' + $(\"#id\").val(),null,false , function(data){\n");
        returndata.append("\t\t\tif(data.code == \"OK\"){\n");
        int count = columns.size();
        for(int i = 0;i < count;i++) {
            Column column = columns.get(i);
            returndata.append("\t\t\t\t$(\"#" + column.getJavaName() + "\").val(data.data." + column.getJavaName() + ");\n");
        }
        returndata.append("\t\t\t}else{\n");
        returndata.append("\t\t\t\tparent.toastr.error(\"非法请求。\");\n");
        returndata.append("\t\t\t}\n");
        returndata.append("\t\t});\n");

        return returndata.toString();
    }
    /**
     *
     * 格式化字段
     *
     * */
    private static String foramatForm(List<Column> columns, Table table){
        StringBuffer returndata = new StringBuffer();

        int count = columns.size();
        for(int i = 0;i < count;i++){

            Column column = columns.get(i);

            //非主键字段，需要页面填写
            if(!column.isPk()){

                returndata.append("\t\t\t\t\t\t\t\t<div class=\"row\">\n");
                returndata.append(HtmlUtils.formatFormtypeEdit(column,table));

                i++;

                if(i >= count){
                    returndata.append("\t\t\t\t\t\t\t\t</div>\n");
                    break;
                }else{
                    column = columns.get(i);
                    returndata.append(HtmlUtils.formatFormtypeEdit(column,table));
                    returndata.append("\t\t\t\t\t\t\t\t</div>\n");
                }
            }

        }

        return returndata.toString();
    }
}
